/*	NAME:
		ICeTEe AddrsTable.h

	WRITTEN BY:
		Michael Schrig
				 
	DESCRIPTION:
		Header file for ICeTEe AddrsTable.c, containing the definition of our
		Address Table.

	___________________________________________________________________________
*/
#ifndef __ICeTEe_ADDRSTABLE__
#define __ICeTEe_ADDRSTABLE__

#include <AppleEvents.h>

//=============================================================================
//		Structures																 
//-----------------------------------------------------------------------------
// The default address table has a "magic" value used to allow a Control
// Panel (for example) to make sure that it gets back what it expects when
// it asks Gestalt for the address table address.  Recommended values of
// "magic" include any four letter character constant *other* than the
// Gestal selector which returns the address table address.  The "version"
// value can be used for a similar sanity checking purpose.  It allows
// changes in the format of the address table to be detected by all
// versions of a cdev/INIT pair.  If a mismatch between expected and actual
// table versions occurs, appropriate action can be taken.  Following these
// two fields  an array of ProcPtrs.
//
// To extend the address table, add fields after theTable.
//-----------------------------------------------------------------------------
#pragma options align=mac68k
typedef struct {
	long			magicNumber;
	long			versionNumber;
	ProcPtr			theTable[3];			// We use only entry 1
	Handle			exclusions;
	Handle			errors;
	AEEventClass	bkEventClass;
	AEEventID		bkEventID;			
} ICeTEeAddressTable;
#pragma options align=reset


#endif
