/*	MacFloater.h
 *
 *		Floating window support library. This is used to provide
 *	floating window support on the Macintosh environment.
 */

#ifndef __MACFLOATER_H__
#define __MACFLOATER_H__

#include <XConfig.h>

#if OPT_MACOS != 1
#error  Macintosh specific header file. Do not include elsewhere
#endif

/************************************************************************/
/*																		*/
/*	Constants															*/
/*																		*/
/************************************************************************/

#define	KFloatingWindow				10
#define KNormalWindow				11

/************************************************************************/
/*																		*/
/*	External Functions (Required Functions)								*/
/*																		*/
/************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

/*
 *	Activation routine; this is required to provide proper window
 *	activate/deactivate support.
 */

extern void DoActivate(WindowPtr,short);	// Needed support routine

#ifdef __cplusplus
}
#endif

/************************************************************************/
/*																		*/
/*	Floating Windows													*/
/*																		*/
/************************************************************************/

/*
 *  Floating window support [MacFloater.c]
 *
 *		These are replacements for the Macintosh functions of similar
 *	name. They are used for creating and maintaining floating windows.
 *
 *		NOTE: This requires the 'WDEF' resource #128 (Infinity Window)
 *	for proper operation. The window definition passed is between
 *	2048 and 2063 to create a floating window.
 */

#ifdef __cplusplus
extern "C" {
#endif

extern WindowPtr MFrontWindow();
extern WindowPtr MLastFloater();	// Last floater window
extern void MSelectWindow(WindowPtr);
extern WindowPtr MNewWindow(Ptr,Rect *,unsigned char *,Boolean,short,WindowPtr,Boolean,long);
extern WindowPtr MNewCWindow(Ptr,Rect *,unsigned char *,Boolean,short,WindowPtr,Boolean,long);
extern void MShowWindow(WindowPtr);
extern void MHideWindow(WindowPtr);
extern void MCloseWindow(WindowPtr);
extern void MDisposeWindow(WindowPtr);
extern void MDragWindow(WindowPtr,Point,const Rect *);

#ifdef __cplusplus
}
#endif

#endif // __MACFLOATER_H__
