/*	test.v
 *
 *		This is a test
 */

define "view" {
	integer;			/* viewID */
	integer;			/* viewRefNum */
	bool;				/* lock left */
	bool;				/* lock top */
	bool;				/* lock top */
	bool;				/* lock bottom */
	integer;			/* left */
	integer;			/* top */
	integer;			/* right */
	integer;			/* bottom */
	bool;				/* visible */
	bool;				/* enabled */
	bool;				/* tab stop */
};

define "wind" {
	integer;			/* window type */
	integer;			/* window id */
	bool;				/* visible */
	integer;			/* left */
	integer;			/* top */
	integer;			/* right */
	integer;			/* bottom */
	
	integer;			/* minx */
	integer;			/* miny */
	integer;			/* maxx */
	integer;			/* maxy */
	integer;			/* initx */
	integer;			/* inity */
	integer;			/* zoomx */
	integer;			/* zoomy */
	
	string;				/* window name */
};

define "dlog" {
	class "wind";
};

define "fred" {
	class "view";
};

define "barn" {
	class "view";
};

define "pbtn" {
	class "view";
	string;
};

define "rbtn" {
	class "view";
	string;
};

define "cbtn" {
	class "view";
	string;
};

define "text" {
	class "view";
	string;
};

define "edit" {
	class "view";
	string;
};

define "grou" {
	class "view";
	string;
};

define "pict" {
	class "view";
	integer;
};

define "list" {
	class "view";
	bool;
};

define "icon" {
	class "view";
	integer;
};

define "scrl" {
	class "view";
	integer;			// page
	integer;			// min
	integer;			// max
	integer;			// value
};

create "test" view "wind" {
	0, 0,
	true,
	-1,-1,-1,-1,
	-1,-1,
	-1,-1,
	-1,-1,
	-1,-1,
	"Test window"
	
	view "view" {
		100, 0,
		true, true, true, false,
		0, 0, 0, 20,
		true, true, false
		
		view "fred" {
			102, 0,
			true, true, false, false,
			5, 2, 45, 18,
			true, true, false
		}
		
		view "barn" {
			103, 0,
			true, true, false, false,
			50, 2, 90, 18,
			true, true, false
		}
	}
	view "view" {
		101, 0,
		true, true, true, true,
		0, 20, 0, 0,
		true, true, false

		view "edit" {
			1, 0,
			true, true, false, false,
			5, 5, 65, 27,
			true, true, false,
			"test box 1"
		}
		view "edit" {
			1, 0,
			true, true, false, false,
			70, 5, 110, 27,
			true, true, false,
			"test box 2"
		}
		
		view "scrl" {
			104, 0,
			true, false, true, true,
			-1, -15, -14, 1,
			true, true, false,
			10, 0, 100, 0
		}
		
		view "grou" {
			105, 0,
			true, true, true, true,
			5, 35, -5, -20,
			true, true, false,
			"Group box test"
			
			view "icon" {			
				105, 0,
				true, true, false, false,
				5, 20, 37, 52,
				true, true, false,
				128
			}
			
			view "pict" {			
				105, 0,
				true, true, false, false,
				5, 54, 37, 86,
				true, true, false,
				128
			}
			
			view "list" {
				107, 0,
				true, true, true, true,
				40, 20, -5, -5,
				true, true, false,
				false
			}
		}
	}
};

create "test2" view "wind" {
	0, 0,
	true,
	-1,-1,-1,-1,
	-1,-1,
	-1,-1,
	-1,-1,
	-1,-1,
	"Test window 2"

	view "edit" {
		1, 0,
		true, true, false, false,
		5, 5, 65, 27,
		true, true, false,
		"test box 1"
	}
	view "edit" {
		1, 0,
		true, true, false, false,
		70, 5, 110, 27,
		true, true, false,
		"test box 2"
	}
};

create "test3" view "dlog" {
	2, 0,			// moveable modal
	true,
	80,100,280,200,
	-1,-1,
	-1,-1,
	-1,-1,
	-1,-1,
	"dialog"
	
	view "pbtn" {
		1, 0,
		true, true, false, false,
		5, 5, 65, 25,
		true, true, false,
		"Ok"
	}
	
	view "rbtn" {
		2, 0,
		true, true, false, false,
		5, 25, 80, 45,
		true, true, false,
		"Radio"
	}
	
	view "cbtn" {
		3, 0,
		true, true, false, false,
		5, 45, 80, 65,
		true, true, false,
		"Check"
	}
	
	view "scrl" {
		4, 0,
		true, true, false, false,
		5, 65, 105, 81,
		true, true, false,
		10, 0, 100, 0
	}
	
	view "text" {
		5, 0,
		true, true, false, false,
		20, 81, 105, 97,
		true, true, false,
		"Hi!"
	}
};
