/*	test.v
 *
 *		This is a test
 */
 
/********************************************/
/*											*/
/*	Definitions								*/
/*											*/
/********************************************/

define "view" {
	integer;			/* viewID */
	integer;			/* viewRefNum */
	bool;				/* lock left */
	bool;				/* lock top */
	bool;				/* lock top */
	bool;				/* lock bottom */
	integer;			/* left */
	integer;			/* top */
	integer;			/* right */
	integer;			/* bottom */
	bool;				/* visible */
	bool;				/* enabled */
	bool;				/* tab stop */
};

define "wind" {
	integer;			/* window type */
	integer;			/* window id */
	bool;				/* visible */
	integer;			/* left */
	integer;			/* top */
	integer;			/* right */
	integer;			/* bottom */
	
	integer;			/* minx */
	integer;			/* miny */
	integer;			/* maxx */
	integer;			/* maxy */
	integer;			/* initx */
	integer;			/* inity */
	integer;			/* zoomx */
	integer;			/* zoomy */
	
	string;				/* window name */
};

define "dlog" {
	class "wind";
};

define "pbtn" {
	class "view";
	string;
};

define "rbtn" {
	class "view";
	string;
};

define "cbtn" {
	class "view";
	string;
};

define "text" {
	class "view";
	string;
};

define "edit" {
	class "view";
	string;
};

define "grou" {
	class "view";
	string;
};

define "pict" {
	class "view";
	integer;
};

define "list" {
	class "view";
	bool;
};

define "icon" {
	class "view";
	integer;
};

define "scrl" {
	class "view";
	integer;			// page
	integer;			// min
	integer;			// max
	integer;			// value
};

define "scrv" {
	class "view";
	bool;				// horizontal scroll bar?
	bool;				// vertical scroll bar?
	bool;				// corner cutout?
	integer;			// ID of the view to move
};

/********************************************/
/*											*/
/*	Local definitions						*/
/*											*/
/********************************************/

define "TEXT" {
	class "view";
};

/********************************************/
/*											*/
/*	My windows								*/
/*											*/
/********************************************/

create "text" view "wind" {
	0, 					// document window type
	0,					// no window ID
	true, 				// visible
	-1,-1,-1,-1,		// use default location
	-1,-1,
	-1,-1,
	-1,-1,
	-1,-1,				// don't restrict size
	
	""					// window has no name
	
	view "scrv" {		// container view
		100,			// container ID
		0,				// no refID
		true,
		true,
		true,
		true,			// lock dimensions to window
		0,
		0,				// flush with upper left
		0,
		0,				// flush with lower right
		true,			// visible
		true,			// enabled
		false,			// not tab stop
		false,			// horizontal/vertical scroll
		true,
		true,
		101				// ID of view to scroll
		
		view "TEXT" {
			101,		// my id is same as in scrv
			0,
			true,true,
			true,true,
			0,0,0,0,	// flush with corners of scroll
			true,true,
			false
		}
	}
};

