/*	AppMain.cpp
 *
 *		This is where the main loop is hidden.
 */

/*  YAAF - Yet another application framework
 *  Copyright (C) 1997 William Edward Woody and In Phase Consulting
 *  
 *  This library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Library
 *  General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or any
 *  later version.
 *  
 *  This library is distributed in the hope that it will be
 *  useful, but WITHOUT ANY WARRANTY; without even the implied
 *  warranty of MERCHANTABIILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU Library General Public License for
 *  more details.
 *  
 *  You should have received a copy of the GNU Library General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *  Boston, MA 02111-1307, USA.
 *  
 *  To contact the author, either e-mail me at
 *  woody@alumni.caltech.edu, or write to us at
 *  
 *          William Edward Woody
 *          In Phase Consulting
 *          1545 Ard Eevin Avenue
 *          Glendale, CA 91202
 */

#include <XError.h>
#include <XApplication.h>

/************************************************************************/
/*																		*/
/*	Internal globals													*/
/*																		*/
/************************************************************************/

#if OPT_WINOS == 1

HINSTANCE	_GInstance;
HINSTANCE	_GPrevInstance;
LPSTR		_GArgString;
int			_GArgShow;

HWND		_GMainWindow;
HWND		_GMDIWindow;

XGWindow	*_GWindow;
XGView		*_GView;

char		_GWindowClass[32];
char		_GMainClass[32];
char		_GViewClass[32];
char		_GDlogClass[32];

#endif

/************************************************************************/
/*																		*/
/*	Main entry point													*/
/*																		*/
/************************************************************************/

/*	main
 *
 *		Where the Macintosh version starts
 */

int main()
{
	XGAppCore *a;
	
	try {
		/*
		 *	Call the startup routine
		 */
		
		a = StartApplication();
		
		/*
		 *	Run the event loop
		 */
		
		if (a) {
			a->Run();
			delete a;
		} else {
			throw XPostError("Application core not initialized");
		}
	}
	
	/*
	 *	Catch random errors
	 */
	
	catch (XError &x) {
		x.DisplayError();
	}
	return 0;
}

#if OPT_WINOS == 1

int WINAPI WinMain(HINSTANCE h, HINSTANCE prev, LPSTR cmd, int show)
{
	/*
	 *	Store the startup variables globally
	 */
	
	_GInstance = h;
	_GPrevInstance = prev;
	_GArgString = cmd;
	_GArgShow = show;
	
	_GMainWindow = NULL;
	_GMDIWindow = NULL;
	
	/*
	 *	Generate the class names. I use the module handle to give
	 *	me a unique identifier for me
	 */
	
	wsprintf(_GWindowClass,"_XGWindow_%08lX",(long)GetModuleHandle(NULL));
	wsprintf(_GMainClass,"_XGMain_%08lX",(long)GetModuleHandle(NULL));
	wsprintf(_GViewClass,"_XGView_%08lX",(long)GetModuleHandle(NULL));
	wsprintf(_GDlogClass,"_XGDialog_%08lX",(long)GetModuleHandle(NULL));
	
	/*
	 *	Call the main function above
	 */
	
	return main();
}

#endif
