/*	XGIViewFactory.cpp
 *
 *		This handles the internal view factory which builds the stuff
 *	that are inside of my class
 */

/*  YAAF - Yet another application framework
 *  Copyright (C) 1997 William Edward Woody and In Phase Consulting
 *  
 *  This library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Library
 *  General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or any
 *  later version.
 *  
 *  This library is distributed in the hope that it will be
 *  useful, but WITHOUT ANY WARRANTY; without even the implied
 *  warranty of MERCHANTABIILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU Library General Public License for
 *  more details.
 *  
 *  You should have received a copy of the GNU Library General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *  Boston, MA 02111-1307, USA.
 *  
 *  To contact the author, either e-mail me at
 *  woody@alumni.caltech.edu, or write to us at
 *  
 *          William Edward Woody
 *          In Phase Consulting
 *          1545 Ard Eevin Avenue
 *          Glendale, CA 91202
 */

#include "factory.h"
#include <XWindow.h>
#include <XDialog.h>

/************************************************************************/
/*																		*/
/*	Default factory														*/
/*																		*/
/************************************************************************/

/*	XGIViewFactory::XGIViewFactory
 *
 *		Internal view factory
 */

XGView *XGIViewFactory::CreateView(long type, XGView *parent, XGArgStream &stream)
{
	switch (type) {
		case 'view':
			return new XGView(parent,stream);
		case 'wind':
			return new XGWindow(stream);
		case 'dlog':
			return new XGDialog(stream);
		default:
			return NULL;
	}
}
