/*	ConfigUtil.cpp
 *
 *		This is the configuration utility
 */

/*  YAAF - Yet another application framework
 *  Copyright (C) 1997 William Edward Woody and In Phase Consulting
 *  
 *  This library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Library
 *  General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or any
 *  later version.
 *  
 *  This library is distributed in the hope that it will be
 *  useful, but WITHOUT ANY WARRANTY; without even the implied
 *  warranty of MERCHANTABIILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU Library General Public License for
 *  more details.
 *  
 *  You should have received a copy of the GNU Library General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *  Boston, MA 02111-1307, USA.
 *  
 *  To contact the author, either e-mail me at
 *  woody@alumni.caltech.edu, or write to us at
 *  
 *          William Edward Woody
 *          In Phase Consulting
 *          1545 Ard Eevin Avenue
 *          Glendale, CA 91202
 */

#include <XConfig.h>

#if OPT_WINOS == 1

/************************************************************************/
/*																		*/
/*	Routines															*/
/*																		*/
/************************************************************************/

/*	EmptyRect
 *
 *		Return true if this is an empty rectangle
 */

bool EmptyRect(Rect *r)
{
	if (r->right <= r->left) return true;
	if (r->bottom <= r->top) return true;
	return false;
}

/*	PtInRect
 *
 *		Point in rectangle test
 */

bool PtInRect(Point where, Rect *r)
{
	if (EmptyRect(r)) return false;
	
	if (r->left > where.h) return false;
	if (r->right <= where.h) return false;
	if (r->top > where.v) return false;
	if (r->bottom <= where.v) return false;
	return true;
}

/*	SectRect
 *
 *		Wrapper for the intersection routine
 */

bool SectRect(Rect *src1, Rect *src2, Rect *dest)
{
	Rect r;
	
	r = *src1;
	if (r.left < src2->left) r.left = src2->left;
	if (r.right > src2->right) r.right = src2->right;
	if (r.top < src2->top) r.top = src2->top;
	if (r.bottom > src2->bottom) r.bottom = src2->bottom;
	
	if (EmptyRect(&r)) {
		dest->left = 0;
		dest->top = 0;
		dest->right = 0;
		dest->bottom = 0;
		return false;
	} else {
		*dest = r;
		return true;
	}
}



#endif // OPT_WINOS
