/*	XGStdPicture.cpp
 *
 *		This is a standard control for displaying a static picture
 */

/*  YAAF - Yet another application framework
 *  Copyright (C) 1997 William Edward Woody and In Phase Consulting
 *  
 *  This library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Library
 *  General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or any
 *  later version.
 *  
 *  This library is distributed in the hope that it will be
 *  useful, but WITHOUT ANY WARRANTY; without even the implied
 *  warranty of MERCHANTABIILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU Library General Public License for
 *  more details.
 *  
 *  You should have received a copy of the GNU Library General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *  Boston, MA 02111-1307, USA.
 *  
 *  To contact the author, either e-mail me at
 *  woody@alumni.caltech.edu, or write to us at
 *  
 *          William Edward Woody
 *          In Phase Consulting
 *          1545 Ard Eevin Avenue
 *          Glendale, CA 91202
 */

#include <XStdImage.h>

/************************************************************************/
/*																		*/
/*	Construction/Destruction											*/
/*																		*/
/************************************************************************/

/*	XGStdPicture::XGStdPicture
 *
 *		Standard picture initialization
 */

XGStdPicture::XGStdPicture(XGView *p, XGArgStream &i) : XGView(p,i)
{
	Init(i.GetInteger());
}

XGStdPicture::XGStdPicture(XGView *p, XGSImageInitRecord &i) : XGView(p,i.v)
{
	Init(i.image);
}

/*	XGStdPicture::~XGStdPicture
 *
 *		Fry this
 */

XGStdPicture::~XGStdPicture()
{
#if OPT_MACOS == 1
	if (fPicture) ReleaseResource((Handle)fPicture);
#endif
}

/************************************************************************/
/*																		*/
/*	Image Drawing														*/
/*																		*/
/************************************************************************/

/*	XGStdPicture::DoDrawView
 *
 *		Draw the picture
 */

void XGStdPicture::DoDrawView(Rect)
{
#if OPT_MACOS == 1
	Rect r;
	XGDraw draw(this);
	
	r = GetContentRect();
	::DrawPicture(fPicture,&r);
#endif
}

/************************************************************************/
/*																		*/
/*	Initialization														*/
/*																		*/
/************************************************************************/

/*	XGStdPicture::Init
 *
 *		Initialize me
 */

void XGStdPicture::Init(short resID)
{
#if OPT_MACOS == 1
	fPicture = GetPicture(resID);
#endif
}
