/*	YAAP_core.vh
 *
 *		Standard resource definitions
 *
 *		This defines the following views
 *
 *		'view'				Standard low level view
 *		'wind'				Standard window
 *		'dlog'				Standard dialog (floating or nonfloating)
 */

/************************************************************************/
/*																		*/
/*	YAAP_core classes													*/
/*																		*/
/************************************************************************/

/*	view
 *
 *		The standard view dialog. Most custom views will be a child of 
 *  this view
 */

define "view" {
	integer;			/* viewID */
	integer;			/* viewRefNum */
	bool;				/* lock left */
	bool;				/* lock top */
	bool;				/* lock top */
	bool;				/* lock bottom */
	dimension;			/* left */
	dimension;			/* top */
	dimension;			/* right */
	dimension;			/* bottom */
	bool;				/* visible */
	bool;				/* enabled */
	bool;				/* tab stop */
};

/*	wind
 *
 *		The standard window. Most custom windows will be a descendant of
 *	this window
 */

define "wind" {
	integer;			/* window type */
	integer;			/* window id */
	bool;				/* visible */
	dimension;			/* left */
	dimension;			/* top */
	dimension;			/* right */
	dimension;			/* bottom */
	
	dimension;			/* minx */
	dimension;			/* miny */
	dimension;			/* maxx */
	dimension;			/* maxy */
	dimension;			/* initx */
	dimension;			/* inity */
	dimension;			/* zoomx */
	dimension;			/* zoomy */
	
	string;				/* window name */
};

/*	dlog
 *
 *		A dialog is simply a window.
 */

define "dlog" {
	class "wind";
};
