/*	YAAP_ctrl.vh
 *
 *		Standard resource definitions for the standard controls
 *
 *		This defines the following views
 *
 *		'pbtn'				Push button
 *		'rbtn'				Radio button
 *		'cbtn'				Check box
 *		'text'				Static text display box
 *		'edit'				Editable text box
 *		'grou'				Group box
 *		'pict'				Picture display
 *		'icon'				Icon display
 *		'list'				List box
 *		'scrl'				Scroll control
 *		'scrv'				Scroll view
 */
 
read "YAAP_core.vh";

/************************************************************************/
/*																		*/
/*	YAAP_stdc buttons													*/
/*																		*/
/************************************************************************/

/*	pbtn
 *
 *		Push button
 */

define "pbtn" {
	class "view";
	string;				/* Default name in button */
};

/*	rbtn
 *
 *		Radio button
 */

define "pbtn" {
	class "view";
	string;				/* Default name in button */
};

/*	cbtn
 *
 *		Check box
 */

define "pbtn" {
	class "view";
	string;				/* Default name in button */
};

/************************************************************************/
/*																		*/
/*	YAAP_stdc text boxes												*/
/*																		*/
/************************************************************************/

/*	text
 *
 *		Text box
 */

define "text" {
	class "view";
	string;				/* Text to display */
};

/*	edit
 *
 *		Editable text box
 */

define "edit" {
	class "view";
	string;				/* Text to display */
};

/*	grou
 *
 *		Group box (draws a box around it's contents)
 */

define "grou" {
	class "view";
	string;				/* Text to display */
};

/************************************************************************/
/*																		*/
/*	YAAP_stdc image display												*/
/*																		*/
/************************************************************************/

/*	pict
 *
 *		Picture display
 */

define "pict" {
	class "view";
	integer;			/* Resource ID of the picture to show */
};

/*	icon
 *
 *		icon display
 */

define "icon" {
	class "view";
	integer;			/* Resource ID of the icon to show */
};

/************************************************************************/
/*																		*/
/*	YAAP_stdc list boxes												*/
/*																		*/
/************************************************************************/

/*	list
 *
 *		List box display
 */

define "list" {
	class "view";
	bool;				/* True if this allows multiple selections */
};

/************************************************************************/
/*																		*/
/*	YAAP_stdc scrolling stuff											*/
/*																		*/
/************************************************************************/

/*	scrl
 *
 *		Scroll bar
 */

define "scrl" {
	class "view";
	integer;			// Default page size
	integer;			// min size
	integer;			// max size
	integer;			// initial value
};

/*	scrv
 *
 *		Scrolling view.
 *
 *	NOTE: The children's locations are calculated based on the scrolling
 *	content area, and not the full size of this view. That basically means
 *	you don't need to know how big the scrollbars are; things inside of this
 *	view will be automatically moved over.
 */

define "scrv" {
	class "view";
	bool;				// horizontal scroll bar?
	bool;				// vertical scroll bar?
	bool;				// corner cutout?
	integer;			// ID of the view to move
};
