/*	lex.h
 *
 *		This contains my parser engine
 */

#ifndef __LEX_H__
#define __LEX_H__

/************************************************************************/
/*																		*/
/*	Lexical Analysis													*/
/*																		*/
/************************************************************************/

/*
 *	Constants
 */

#define	KLexInteger				256
#define KLexString				257
#define KLexToken				258
#define KLexReal				259

/*
 *	Predefined tokens
 */

#define	KTokenDefine			300
#define	KTokenBool				301
#define	KTokenString			302
#define	KTokenInteger			303
#define	KTokenClass				304
#define	KTokenCreate			305
#define	KTokenTrue				306
#define	KTokenFalse				307
#define	KTokenView				308
#define KTokenRead				309
#define KTokenDimension			310

/*
 *	Externals
 */

extern void						PrintError(char *arg,...);
extern void						InitLexEngine(void);
extern void						EndLexEngine(void);
extern void						ReadLexFile(char *);
extern void						PushBackToken(int);
extern int						GetNextToken();

/*
 *	Token values
 */

extern long						GInteger;
extern double					GReal;
extern char						GToken[];


#endif
