/*	viewformat.h
 *
 *		This stores the definition of a view
 */

#ifndef __VIEWFORMAT_H__
#define __VIEWFORMAT_H__

/************************************************************************/
/*																		*/
/*	File Foramt Records													*/
/*																		*/
/************************************************************************/

/*	ViewRecord
 *
 *		This is the format of the view record contents
 */

typedef struct ViewRecord {
	long			viewsize;
	long			viewchild;
	long			viewsibling;
	long			viewtype;
} ViewRecord;

/************************************************************************/
/*																		*/
/*	View format structures												*/
/*																		*/
/************************************************************************/

/*	ViewElemRecord
 *
 *		An element or record definition
 */

typedef struct ViewElemRecord {
	struct ViewElemRecord	*next;
	short					type;
} ViewElemRecord;

/*
 *	ViewElemRecord.type
 */

#define	KViewBoolean		1
#define KViewInteger		2
#define KViewString			3
#define KViewDimension		4

/*	ViewFormatRecord
 *
 *		How a view is defined
 */

typedef struct ViewFormatRecord {
	struct ViewFormatRecord	*next;
	
	long					vtoken;
	struct ViewFormatRecord	*base;			/* Base class */
	struct ViewElemRecord	*list;
} ViewFormatRecord;

/************************************************************************/
/*																		*/
/*	View format routines												*/
/*																		*/
/************************************************************************/

extern void					ParseFile(char *);


#endif
