/*	XCursorUtil.h
 *
 *		This is the header file for the cursor utilities. This provides
 *	a portable mechanism for changing the mouse cursor
 */

/*  YAAF - Yet another application framework
 *  Copyright (C) 1997 William Edward Woody and In Phase Consulting
 *  
 *  This library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Library
 *  General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or any
 *  later version.
 *  
 *  This library is distributed in the hope that it will be
 *  useful, but WITHOUT ANY WARRANTY; without even the implied
 *  warranty of MERCHANTABIILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU Library General Public License for
 *  more details.
 *  
 *  You should have received a copy of the GNU Library General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *  Boston, MA 02111-1307, USA.
 *  
 *  To contact the author, either e-mail me at
 *  woody@alumni.caltech.edu, or write to us at
 *  
 *          William Edward Woody
 *          In Phase Consulting
 *          1545 Ard Eevin Avenue
 *          Glendale, CA 91202
 */

#ifndef __XCURSORUTIL_H__
#define __XCURSORUTIL_H__

#if defined(__MWERKS__)
	#if defined(macintosh)
		#pragma options align=power
	#endif
	#if defined(__INTEL__)
		#pragma pack(push,2)
	#endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

/************************************************************************/
/*																		*/
/*	Cursor Utilities													*/
/*																		*/
/************************************************************************/

extern void			InitCursorAnimation(short *alist);

extern void			SetCursorID(short);
extern void			WaitCursor(void);
extern void			NormalCursor(void);

/************************************************************************/
/*																		*/
/*	Predefined Cursors													*/
/*																		*/
/************************************************************************/

#define	KNormalCursor	0
#define KIBeamCursor	1
#define KCrossCursor	2
#define KPlusCursor		3
#define KWatchCursor	4


#ifdef __cplusplus
}
#endif

#if defined(__MWERKS__)
	#if defined(macintosh)
		#pragma options align=reset
	#endif
	#if defined(__INTEL__)
		#pragma pack(pop)
	#endif
#endif

#endif /* __XCURSORUTIL_H__ */
