/*	XStdControls.h
 *
 *		This is the primary header for the initialization routines which
 *	are used for my standard control library
 */

/*  YAAF - Yet another application framework
 *  Copyright (C) 1997 William Edward Woody and In Phase Consulting
 *  
 *  This library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Library
 *  General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or any
 *  later version.
 *  
 *  This library is distributed in the hope that it will be
 *  useful, but WITHOUT ANY WARRANTY; without even the implied
 *  warranty of MERCHANTABIILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU Library General Public License for
 *  more details.
 *  
 *  You should have received a copy of the GNU Library General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *  Boston, MA 02111-1307, USA.
 *  
 *  To contact the author, either e-mail me at
 *  woody@alumni.caltech.edu, or write to us at
 *  
 *          William Edward Woody
 *          In Phase Consulting
 *          1545 Ard Eevin Avenue
 *          Glendale, CA 91202
 */

#ifndef __XSTDCONTROLS_H__
#define __XSTDCONTROLS_H__

/************************************************************************/
/*																		*/
/*	Common control messages												*/
/*																		*/
/************************************************************************/

/*	KEventGetFont
 *
 *		This message is sent to the parent of this control. This gives
 *	the parent the opportunity to use a different font other than the
 *	default system font.
 *
 *		The return value is different on the Macintosh than on Windows--
 *	on the Macintosh the return value is the font and size of the
 *	font to use (with the font in the high word and the size in the
 *	low word). On Windows, this is the HFont handle.
 *
 *		If 0, the default font is used.
 *
 *		The values of the arguments are:
 *
 *			arg			ViewID of the control making the request
 *			parg		Pointer to the control
 */

#define	KEventGetFont		'gfnt'

/************************************************************************/
/*																		*/
/*	External Routines													*/
/*																		*/
/************************************************************************/

extern void XGInitStandardControls(void);
extern void XGKillStandardControls(void);

#endif // __XSTDCONTROLS_H__
