/*	XStdImage.h
 *
 *		Standard text controls
 */

/*  YAAF - Yet another application framework
 *  Copyright (C) 1997 William Edward Woody and In Phase Consulting
 *  
 *  This library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Library
 *  General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or any
 *  later version.
 *  
 *  This library is distributed in the hope that it will be
 *  useful, but WITHOUT ANY WARRANTY; without even the implied
 *  warranty of MERCHANTABIILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU Library General Public License for
 *  more details.
 *  
 *  You should have received a copy of the GNU Library General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *  Boston, MA 02111-1307, USA.
 *  
 *  To contact the author, either e-mail me at
 *  woody@alumni.caltech.edu, or write to us at
 *  
 *          William Edward Woody
 *          In Phase Consulting
 *          1545 Ard Eevin Avenue
 *          Glendale, CA 91202
 */

#ifndef __XSTDIMAGE_H__
#define __XSTDIMAGE_H__

#include <XView.h>
#include <XEvent.h>

#if OPT_MACOS == 1
#include <Icons.h>
#endif

#if defined(__MWERKS__)
	#if defined(macintosh)
		#pragma options align=power
	#endif
	#if defined(__INTEL__)
		#pragma pack(push,2)
	#endif
#endif


/************************************************************************/
/*																		*/
/*	Internal structures													*/
/*																		*/
/************************************************************************/

/*	XGSImageInitRecord
 *
 *		This contains the common initialization parameters to initialize
 *	a button
 */

struct XGSImageInitRecord {
	XGSViewInitRecord			v;
	short						image;
};

/************************************************************************/
/*																		*/
/*	Standard Classes													*/
/*																		*/
/************************************************************************/

/*	XGStdPicture
 *
 *		Standard picture display object.
 */

class XGStdPicture : public XGView {
	public:
								XGStdPicture(XGView *parent, XGArgStream &init);
								XGStdPicture(XGView *parent, XGSImageInitRecord &init);
		virtual					~XGStdPicture();
		
		/*
		 *	Display hooks
		 */
		
		void					DoDrawView(Rect);
		
	private:
		void					Init(short);
		
#if OPT_MACOS == 1
		PicHandle				fPicture;
#endif
};

/*	XGStdIcon
 *
 *		Standard image display object
 */

class XGStdIcon : public XGView {
	public:
								XGStdIcon(XGView *parent, XGArgStream &init);
								XGStdIcon(XGView *parent, XGSImageInitRecord &init);
		virtual					~XGStdIcon();
		
		/*
		 *	Display hooks
		 */
		
		void					DoDrawView(Rect);
		
	private:
		void					Init(short);

#if OPT_MACOS == 1
		bool					fColor;
		union {
			CIconHandle			fCIcon;
			Handle				fIcon;
		};
#endif
};

#if defined(__MWERKS__)
	#if defined(macintosh)
		#pragma options align=reset
	#endif
	#if defined(__INTEL__)
		#pragma pack(pop)
	#endif
#endif

#endif
